import 'package:flutter/material.dart';
import 'package:loading/indicator.dart';

class BallClipRotateIndicator extends Indicator {
  var scaleFloat = 1.0;
  var degrees=0.0;

  @override
  paint(Canvas canvas, Paint paint, Size size) {
    paint.style = PaintingStyle.stroke;
    paint.strokeWidth = 3;

    var circleSpacing = 12;
    var x = size.width / 2;
    var y = size.height / 2;
    canvas.translate(x, y);
    canvas.scale(scaleFloat, scaleFloat);
    canvas.rotate(degrees);
    var rectF = Rect.fromLTRB(-x + circleSpacing, -y + circleSpacing,
        0 + x - circleSpacing, 0 + y - circleSpacing);
    canvas.drawArc(rectF, -45, 270, false, paint);
  }

  @override
  List<AnimationController> animation() {
    var controllers = List<AnimationController>();

    var sizeController = new AnimationController(
        duration: Duration(milliseconds: 750), vsync: context);
    var scaleAnim =
        new Tween<double>(begin: 1.0, end: 0.5).animate(sizeController);
    var degreesAnim =
        new Tween<double>(begin: 0, end: 360.0).animate(sizeController);
    sizeController.addListener(() {
      scaleFloat = scaleAnim.value;
      degrees = degreesAnim.value;
      postInvalidate();
    });
    controllers.add(sizeController);
    return controllers;
  }

  @override
  void startAnim(AnimationController controller) {
    controller.repeat(reverse: true);
  }
}
